<html>
<head>
<title>RManNotes: Writing Shaders: Surface</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="writing_shaders.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="surf1.html">previous</a>
|
<a href="disp.html">next</a>
|
<a href="index.html">writing shaders: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1>Surface Shaders, Part II</h1>

<p>
This section describes techniques for incorporating illumination
models -- specifically the "plastic" illumination model --
into surface shaders. It does not discuss the theory behind 
illumination models or how parameters of the plastic model should
be used.
</p>

<h2><a name="illum">Illumination</a></h2>

<p>
The most commonly used illumination model in RenderMan shaders is 
the so-called "plastic" illumination 
model which incorporates diffuse, specular, and ambient reflection. We
can add the plastic illumination model to shaders as a final layer
(after the other layers have determined the surface color)
or we can incorporate it into individual layers to achieve surfaces
with non-uniform illumination.
</p>

<p>
You'll find that in most shaders which use the plastic model, the same
set of instance variables are used. The table below briefly summarizes
those variables.
</p>

<center>
<table border cellpadding=5 width=80%>
<caption>Plastic Illumination Variables</caption>
<th align=left>name<th>type<th>description
<tr><td>Ka<td>float<td>ambient reflection constant 
-- the percentage of ambient light in the
scene reflected by this surface
<tr><td>Kd<td>float<td>diffuse reflection constant
-- the percentage of diffuse light in the
scene reflected by this surface
<tr><td>Ks<td>float<td>specular reflection constant
-- the percentage of specular light in the
scene reflected by this surface (i.e. brightness of 
specular highlights)
<tr><td>roughness<td>float<td>specular roughness constant (1 = very rough,
0.0001 = very smooth) -- the concentration (brightness) of specular 
highlights
<tr><td>specular<td>color<td>specular reflection color
</table>
</center>

<p>
In addition, certain auxillary variables will be used in RManNotes
shaders to implement the illumination model.
</p>

<center>
<table border cellpadding=5>
<caption>Auxillary Variables</caption>
<tr><td>Nf<td>point<td>forward facing normal
<tr><td>V<td>point<td>view vector
</table>
</center>

<p>
Let's assume that <code>surface_color</code> contains the surface color
of the object without illumination. We can compute a new value for
<code>surface_color</code> which will include the plastic illumination
model with the following code fragment. Note that this fragment declares
<code>Nf</code> and <code>V</code> locally and assumes that 
<code>Ka</code>, <code>Kd</code>, <code>Ks</code>, <code>roughness</code>,
 and <code>specularcolor</code> are instance variables.
</p>

<p><pre><small>
	point Nf, V;
	
	...

	Nf = faceforward(normalize(N), I); 
	V = -normalize(I);

	surface_color = surface_color * (Ka * ambient() + Kd * diffuse(Nf))
		+ specularcolor * Ks * specular(Nf, V, roughness);
</small></pre></p>

<center>
<table>
<tr><td><a href="surf2.1.jpg"><img src="surf2.1.gif"></a>
<tr align=center><td><a href="surf2.1.sl">surf2.1.sl</a>, Os = (1,1,1)
</table>
</center>

<p>
The <a href="surf2.1.sl">surf2.1.sl</a> shader shown above contains a simple
screen pattern and incorporates the plastic illumination model
using the computations and variables described above.
</p>

<h2><a name="hetero">Heterogeneous Illumination</a></h2>

<p>
The shader presented in the previous section 
(<a href="surf2.1.sl">surf2.1.sl</a>) uses the same illumination 
computation for all layers.
Because the illumination is treated independently of the underlying surface 
color, the ball appears to may made of one multi-colored material. 
By varying the illumination per layer 
(as in <a href="surf2.2.sl">surf2.2.sl</a>), 
we can generate the effect of a surface 
composed of differing materials. 
</p>

<center>
<table>
<tr><td><a href="surf2.2.jpg"><img src="surf2.2.gif"></a>
<tr align=center><td><a href="surf2.1.sl">surf2.1.sl</a> (left) and <a href="surf2.2.sl">surf2.2.sl</a> (right)
</table>
</center>

<p>
In the image above, the sphere on the left
shows uniform illumination of layers; the sphere on the right shows non-uniform
illumination. In particular note that on the right sphere, the highlight 
applies only to the foreground layer and that ambient light is lacking
in the background layer.
</p>

<p><img src="black_line.gif"></p>
<p>
<a href="surf1.html">previous</a>
|
<a href="disp.html">next</a>
|
<a href="index.html">writing shaders: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 5/6/96</i></small></p>

</body>
</html>
